SystemOrganization addCategory: #'ShoutMonticello-enabler'!

!MCPatchBrowser methodsFor: '*ShoutMonticello-addition' stamp: 'tween 5/1/2004 13:57'!
stylerAboutToStyle: aSHTextStyler

	Preferences syntaxHighlightingAsYouType ifFalse: [^false].
	selection ifNotNil: [
		selection isAddition | selection isRemoval
			ifTrue:[
				selection definition isOrganizationDefinition
					ifTrue:[^false].
				aSHTextStyler classOrMetaClass: self selectedClassOrMetaClass.
				^true].
		"could use smart diff styler to style modifications"
		selection isModification ifTrue:[^false].
		^false].
	^false! !

!MCTool methodsFor: '*ShoutMonticello-override' stamp: 'tween 5/9/2004 12:00'!
textMorph: aSymbol
	| textMorph styler |
	
	^(MorphicTextEditor default canUnderstand: #styler:)
		ifFalse:[PluggableTextMorph on: self text: aSymbol accept: (aSymbol, ':') asSymbol]
		ifTrue:[
			textMorph := MorphicTextEditor default new
				styler:((styler := SHTextStylerST80 new)
					formatAssignments: false;
					font: Preferences standardCodeFont;
					when: #aboutToStyle send: #stylerAboutToStyle: to: self with: styler).
			textMorph
				on: self 
				text: aSymbol 
				accept: (aSymbol, ':') asSymbol
				readSelection: nil
				menu: nil]! !

!MCTool methodsFor: '*ShoutMonticello-addition' stamp: 'tween 5/1/2004 10:50'!
stylerAboutToStyle:aStyler
	^false! !

Object subclass: #SHMCClassDefinition
	instanceVariableNames: 'classDefinition items meta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoutMonticello-enabler'!

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/1/2004 12:20'!
sharedPools
	| d |
	d := Set new.
	classDefinition poolDictionaries do:[:each |
		d add: [Smalltalk at: each asSymbol ifAbsent:[nil]] ].
	^d! !

!SHMCClassDefinition methodsFor: 'act like environment' stamp: 'tween 5/9/2004 12:38'!
hasBindingThatBeginsWith: aString

	(Smalltalk hasBindingThatBeginsWith: aString) ifTrue: [^true].
	items do:[:each |
		(each isClassDefinition and: [each className beginsWith: aString])
			ifTrue:[^true]].
	^false! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/1/2004 12:28'!
theNonMetaClass
	^self copy meta: false; yourself! !

!SHMCClassDefinition class methodsFor: 'as yet unclassified' stamp: 'tween 5/1/2004 12:27'!
classDefinition: aMCClassDefinition items: anObject meta: aBoolean
	^self new
		classDefinition: aMCClassDefinition;
		items: anObject;
		meta: aBoolean;
		yourself! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/9/2004 12:21'!
environment
	^self! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 11:37'!
items: anObject
	items := anObject! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 11:38'!
classDefinition: aMCClassDefinition
	classDefinition := aMCClassDefinition! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 12:35'!
allInstVarNames
	| superclassOrDef answer classOrDef instVars|
	
	answer := meta
		ifTrue:[classDefinition classInstVarNames asArray]
		ifFalse:[	classDefinition instVarNames asArray].
	classOrDef := classDefinition.
	[superclassOrDef := (classOrDef isKindOf: MCClassDefinition)
		ifTrue:[ |s|
			s := classOrDef superclassName.
			items 
				detect: [:ea | ea isClassDefinition and: [ea className = s]]
				ifNone: [Smalltalk at: s asSymbol ifAbsent:[nil]]]
		ifFalse:[ | sc |
			sc := classOrDef superclass.
			sc ifNotNil:[
				items 
					detect: [:ea | ea isClassDefinition and: [ea className = sc name asString]]
					ifNone: [sc]	]].
	superclassOrDef isNil
	] whileFalse:[
		instVars := (superclassOrDef isKindOf: MCClassDefinition)
			ifTrue:[
				meta 
					ifTrue:[superclassOrDef classInstVarNames]
					ifFalse:[superclassOrDef instVarNames]]
			ifFalse:["real"
				meta
					ifTrue:[superclassOrDef theNonMetaClass class  instVarNames]
					ifFalse:[superclassOrDef theNonMetaClass instVarNames]].		
		answer := answer, instVars.
		classOrDef := superclassOrDef].
	^answer! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 12:26'!
meta: aBoolean
	meta := aBoolean! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/1/2004 12:17'!
classPool
	| d |
	d := Dictionary new.
	classDefinition classVarNames do:[:each |
		d at: each put: nil].
	^d! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 12:13'!
withAllSuperclasses
	| superclassOrDef answer classOrDef |
	
	answer := Array with: self.
	classOrDef := classDefinition.
	[superclassOrDef := (classOrDef isKindOf: MCClassDefinition)
		ifTrue:[ |s|
			s := classOrDef superclassName.
			items 
				detect: [:ea | ea isClassDefinition and: [ea className = s]]
				ifNone: [Smalltalk at: s asSymbol ifAbsent:[nil]]]
		ifFalse:[ | sc |
			sc := classOrDef superclass.
			sc ifNotNil:[
				items 
					detect: [:ea | ea isClassDefinition and: [ea className = sc name asString]]
					ifNone: [sc]	]].
	superclassOrDef isNil
	] whileFalse:[
		answer := answer, (Array with: superclassOrDef).
		classOrDef := superclassOrDef].
	^answer! !

!SHMCClassDefinition methodsFor: 'act like environment' stamp: 'tween 5/9/2004 12:27'!
bindingOf: aSymbol
	| binding |
	(binding := Smalltalk bindingOf: aSymbol)
		ifNotNil: [^binding].
	items do:[:each |
		(each isClassDefinition and: [each className = aSymbol])
			ifTrue:[^aSymbol -> each]].
	^nil! !

!MCSnapshotBrowser methodsFor: '*ShoutMonticello-addition' stamp: 'tween 5/9/2004 12:55'!
hasBindingThatBeginsWith: aString

	(Smalltalk hasBindingThatBeginsWith: aString) ifTrue: [^true].
	items do:[:each |
		(each isClassDefinition and: [each className beginsWith: aString])
			ifTrue:[^true]].
	^false! !

!MCSnapshotBrowser methodsFor: '*ShoutMonticello-addition' stamp: 'tween 5/9/2004 12:55'!
bindingOf: aSymbol
	| binding |
	(binding := Smalltalk bindingOf: aSymbol)
		ifNotNil: [^binding].
	items do:[:each |
		(each isClassDefinition and: [each className = aSymbol])
			ifTrue:[^aSymbol -> each]].
	^nil! !

!MCSnapshotBrowser methodsFor: '*ShoutMonticello-addition' stamp: 'tween 5/9/2004 12:57'!
stylerAboutToStyle: aSHTextStyler
	| classDef s |

	Preferences syntaxHighlightingAsYouType ifFalse: [^false].
	self switchIsComment ifTrue:[^false].
	methodSelection ifNotNil: [
		classDef := items 
			detect: [:ea | ea isClassDefinition and: [ea className = classSelection]]
			ifNone: [
				(s := Smalltalk at:classSelection ifAbsent:[nil])
					ifNotNil:[ s asClassDefinition]].
		aSHTextStyler classOrMetaClass: (classDef ifNotNil: [
			SHMCClassDefinition classDefinition: classDef items: items meta: switch = #class]).
		aSHTextStyler environment: self.
		^true].
	protocolSelection ifNotNil: [^false].
	(classSelection notNil and: [self text ~= 'This class is defined elsewhere.']) 
		ifTrue:[
			aSHTextStyler classOrMetaClass: nil.
			aSHTextStyler environment: self.
			^true].
	^false! !
